Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 175)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 188)
@@ -1,3 +1,7 @@
 /* -*- c++ -*-
+ * File         : vci_cc_xcache_wrapper_v4.cpp
+ * Date         : 26/11/2011
+ * Copyright    : UPMC / LIP6
+ * Authors      : Alain Greiner 
  *
  * SOCLIB_LGPL_HEADER_BEGIN
@@ -21,85 +25,24 @@
  * SOCLIB_LGPL_HEADER_END
  *
- * Copyright (c) UPMC, Lip6, SoC
- *         Alain Greiner <alain.greiner@lip6.fr>, 2008
+ * Copyright (c) UPMC, Lip6
+ *         Alain Greiner <alain.greiner@lip6.fr>, 2011
  *
- * Maintainers: alain eric.guthmuller@polytechnique.edu nipo
+ * Maintainers: alain 
  */
 
-/////////////////////////////////////////////////////////////////////////////
-// History
-// - 25/04/2008
-//   The existing vci_xcache component has been extended to include 
-//   a VCI target port to support a directory based coherence protocol.
-//   Two types of packets can be send by the L2 cache to the L1 cache
-//   * INVALIDATE packets : length = 1
-//   * UPDATE packets : length = n + 2   
-//   The CLEANUP packets are sent by the L1 cache to the L2 cache, 
-//   to signal a replaced cache line.
-// - 12/08/2008
-//   The vci_cc_xcache_wrapper component instanciates directly the processsor 
-//   iss, in order to supress the processor/cache interface.
-//   According to the VCI advanced specification, this component uses one 
-//   word VCI CMD packets for MISS transactions, and accept one word VCI RSP
-//   packets for Write burst  transactions.
-//   The write buffer has been modified to use the WriteBuffer object. 
-//   A VCI write burst is constructed when two conditions are satisfied :
-//   The processor make strictly successive write requests, and they are
-//   in the same cache line. The write buffer performs re-ordering, to
-//   respect the contiguous addresses VCI constraint. In case of several
-//   WRITE_WORD requests in the same word, only the last request is conserved.
-//   In case of several WRITE_HALF or WRITE_WORD requests in the same word,
-//   the requests are merged in the same word. In case of uncached write
-//   requests, each request is transmited as a single VCI transaction.
-//   Both the data & instruction caches can be flushed in one single cycle.
-///////////////////////////////////////////////////////////////////////////////
-
-#include <iomanip>
-#include "arithmetics.h"
-#include "size.h"
 #include "../include/vci_cc_xcache_wrapper_v4.h"
-namespace soclib { 
-  namespace caba {
+
+#define DEBUG_GLOBAL		0
+#define DEBUG_DCACHE		0
+#define DEBUG_ICACHE		0
+
+#define DEBUG_START_CYCLE	0
+#define DEBUG_ID		    0
+
+namespace soclib { namespace caba {
+
     namespace {
-
-// =====[ DEBUG ]====================================
-
-#define ASSERT_VERBOSE
-#define ASSERT_NCYCLES m_cpt_total_cycles
-
-#include "debug.h"
-
-#if CC_XCACHE_WRAPPER_DEBUG
-# define PRINTF(msg...) PRINTF_COND(m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN,msg)
-#else
-# define PRINTF(msg...)
-#endif
-
-/////////////////////////////////////////////////////////////////////
-// Management of address stocked in icache/dcache/mwbuf in case
-// of multiple bank implementation 
-/////////////////////////////////////////////////////////////////////
-
-// =====[ MULTI_CACHE ]==============================
-
-#if (CC_XCACHE_WRAPPER_MULTI_CACHE==1)
-# define get_num_icache(     addr,num_cpu)   get_num_cache     (addr)          
-# define get_num_icache_only(addr,num_cpu)   get_num_cache_only(addr)          
-# define set_num_icache(     addr,num_cache) set_num_cache     (addr,num_cache)
-# define set_num_icache_only(addr,num_cache) set_num_cache_only(addr,num_cache)
-#elif (CC_XCACHE_WRAPPER_MULTI_CACHE==2)
-# define get_num_icache(     addr,num_cpu)   num_cpu
-# define get_num_icache_only(addr,num_cpu)   num_cpu
-# define set_num_icache(     addr,num_cache) do  {} while (0)
-# define set_num_icache_only(addr,num_cache) addr
-#else
-#error "Invalid value to CC_XCACHE_WRAPPER_MULTI_CACHE"
-#endif
-# define get_num_dcache(     addr)           get_num_cache     (addr)          
-# define get_num_dcache_only(addr)           get_num_cache_only(addr)          
-# define set_num_dcache(     addr,num_cache) set_num_cache     (addr,num_cache)
-# define set_num_dcache_only(addr,num_cache) set_num_cache_only(addr,num_cache)
-
-      const char *dcache_fsm_state_str[] = {
+      const char *dcache_fsm_state_str[] = 
+      {
         "DCACHE_IDLE",
         "DCACHE_WRITE_UPDT",
@@ -108,13 +51,14 @@
         "DCACHE_MISS_UPDT",
         "DCACHE_UNC_WAIT",
-        "DCACHE_SC_WAIT",
         "DCACHE_INVAL",
+        "DCACHE_INVAL_GO",
         "DCACHE_SYNC",
         "DCACHE_ERROR",
         "DCACHE_CC_CHECK",
         "DCACHE_CC_INVAL",
-        "DCACHE_CC_CLEANUP",
+        "DCACHE_CC_UPDT",
       };
-      const char *icache_fsm_state_str[] = {
+      const char *icache_fsm_state_str[] = 
+      {
         "ICACHE_IDLE",
         "ICACHE_MISS_VICTIM",
@@ -123,9 +67,10 @@
         "ICACHE_UNC_WAIT",
         "ICACHE_ERROR",
-        "ICACHE_CC_CLEANUP",
         "ICACHE_CC_CHECK",
         "ICACHE_CC_INVAL",
+        "ICACHE_CC_UPDT",
       };
-      const char *cmd_fsm_state_str[] = {
+      const char *cmd_fsm_state_str[] = 
+      {
         "CMD_IDLE",
         "CMD_INS_MISS",
@@ -136,5 +81,6 @@
         "CMD_DATA_SC",
       };
-      const char *rsp_fsm_state_str[] = {
+      const char *rsp_fsm_state_str[] = 
+      {
         "RSP_IDLE",
         "RSP_INS_MISS",
@@ -145,5 +91,6 @@
         "RSP_DATA_SC",
       };
-      const char *tgt_fsm_state_str[] = {
+      const char *tgt_fsm_state_str[] = 
+      {
         "TGT_IDLE",
         "TGT_UPDT_WORD",
